"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringSerializer = exports.StringDeserializer = exports.JSONSerializer = exports.JSONDeserializer = void 0;
class JSONDeserializer {
    deserialize(value, opts) {
        return {
            data: JSON.parse(value.body.toString('utf8')),
            pattern: opts.pattern,
        };
    }
}
exports.JSONDeserializer = JSONDeserializer;
class JSONSerializer {
    serialize(value) {
        return Buffer.from(JSON.stringify(value.data));
    }
}
exports.JSONSerializer = JSONSerializer;
class StringDeserializer {
    deserialize(value, opts) {
        return {
            data: value.body.toString('utf8'),
            pattern: opts.pattern,
        };
    }
}
exports.StringDeserializer = StringDeserializer;
class StringSerializer {
    serialize(value) {
        return Buffer.from(String(value.data));
    }
}
exports.StringSerializer = StringSerializer;
//# sourceMappingURL=serialization.js.map